// $Id: TopProcess.cc,v 1.9.2.3 1998/11/18 17:37:06 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "TopProcess.h"
#include "LocalStats.h"

#include <iostream.h>
#include <iomanip.h>

void TopProcess::taskStarted(Thread *th) {
	Process::taskStarted(th);
	StatInc(theSubmMeter);
	theSubm.tick();
}

void TopProcess::taskStopped(Thread *th) {
	Process::taskStopped(th);
	StatInc(theComplMeter);
	TheComplCount++; // global kludge
	theCompl.tick();
}

void TopProcess::report(ostream &os) const {
	os
		<< theSubm.count()
		<< "\t " << theSubm
		<< "\t " << theCompl.count()
		<< "\t " << theCompl
		<< "\t " << theErr.count()
		<< "\t " << (theSubm.count() - theCompl.count());
}
