// $Id: XactIOThread.cc,v 1.6.2.3 1998/11/17 20:54:55 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "XactIOThread.h"


XactIOThread::~XactIOThread() {
	if (theReserv)
		TheSelectLoop.clearFD(theReserv);
}

void XactIOThread::checkProgress() {
	XactThread::checkProgress();
	if (!done())
		state(theConn->ioReady(theReserv.dir()) ? thRunnable : thSleeping);
}

void XactIOThread::init() {
	XactThread::init();
	if (theConn)
		theReserv = TheSelectLoop.setFD(theConn->socket(), theReserv.dir(), this);
	else
		beActive(thDone);
}


void XactIOThread::run() {
	const IOBuffer &buf = workBuf();
	IOBuffer::State bufState = buf.state();

	doIO();

	if (buf.state() != bufState)
		sendBufChange();
	checkProgress();
	// restore reservation if needed
	// XXX: ioReady() above does not guarantee we had a reservation
	if (!done() && !theReserv && !theConn->ioReady(theReserv.dir()))
		theReserv = TheSelectLoop.setFD(theConn->socket(), theReserv.dir(), this);
}
