// $Id: LocalStats.h,v 1.2.2.3 1998/11/18 17:37:07 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _LOCAL_STATS_H_
#define _LOCAL_STATS_H_

#include "Stats.h"
#include "RateMeter.h"
#include "Trace.h"

#include <iostream.h>


// holds various counters
class LocalStats {
	public:
		LocalStats();
		~LocalStats();

		void collectTraces();

		double dhr() const; // document hit ratio, [0:100]

		void report(ostream &os) const;
	
	public:
		/* connections */
		Count theConnConnectCount;
		Count theConnAcceptCount;
		Count theConnCloseCount;
		Count theConnReadCount;
		Count theConnWriteCount;

		/* xactions */
		Count theXactErrCount;
		Count theXactHitCount;
		Count theXactMissCount;
		RateMeter theSubmMeter;
		RateMeter theComplMeter;

		/* traces */
		Trace *theRespTimeTrace;
		Trace *theRespSizeTrace;

		/* other */
		Count the304SentCount;
};

extern LocalStats *ThePhaseStats;
extern LocalStats *ThePingStats;

extern Count TheComplCount; // global kludge

// not very efficient, but straightforward
#define StatInc(measure) (ThePhaseStats->measure)++, (ThePingStats->measure)++

#endif
