#ifndef _REP_EATER_H_
#define _REP_EATER_H_ "$Id: RepEater.h,v 1.4.2.1 1998/09/22 07:44:20 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "RepContThread.h"
#include "RepCBlock.h"

// analyzes incoming content and stops reader when needed
class RepEater: public RepContThread {
	public:
		RepEater(): theParseState(psWaitHead) {}
		class Thread *clone() const { return new RepEater(); }

		virtual const char *name() const { return "RepEater"; }

	protected:
		virtual Size workOffset() const { return theConn->theReaderBuf.outOffset(); }
		virtual IOBuffer &workBuf() const { return theConn->theReaderBuf; }

		virtual void doContent();

	protected:
		RepCBlock theCBlock;
		ParseState theParseState;
};

#endif
